// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../../../../packages/inferno/inferno-shared
//   ../../../../packages/inferno/inferno-vnode-flags

declare module 'inferno' {
    /** TypeDoc Comment */
    import { NO_OP } from "inferno-shared";
    import { default as _VNodeFlags } from "inferno-vnode-flags";
    import { cloneVNode, createVNode, getFlagsForElementVnode, InfernoChildren, InfernoInput, normalize as internal_normalize, options, Props, Refs as _Refs, Root as _Root, VNode } from "inferno/core/implementation";
    import { isUnitlessNumber as internal_isUnitlessNumber } from "inferno/DOM/constants";
    import { linkEvent } from "inferno/DOM/events/linkEvent";
    import { patch as internal_patch } from "inferno/DOM/patching";
    import { createPortal, createRenderer, findDOMNode, render } from "inferno/DOM/rendering";
    import { componentToDOMNodeMap as internal_DOMNodeMap, EMPTY_OBJ } from "inferno/DOM/utils/common";
    import { Component } from "inferno/core/component";
    export const VNodeFlags: _VNodeFlags;
    export const Root: _Root;
    export const Refs: _Refs;
    const version: string | undefined;
    const _default: {
        EMPTY_OBJ: {};
        NO_OP: string;
        Component: typeof Component;
        cloneVNode: (vNodeToClone: VNode, props?: Props | undefined, ..._children: InfernoChildren[]) => VNode;
        createPortal: (children: any, container: any) => VNode;
        createRenderer: (parentDom?: any) => (lastInput: any, nextInput: any) => void;
        createVNode: (flags: number, type: any, className?: string | null | undefined, children?: InfernoChildren, props?: Props | null | undefined, key?: any, ref?: ((node?: Element | null | undefined) => void) | _Refs | null | undefined, noNormalise?: boolean | undefined) => VNode;
        findDOMNode: (ref: any) => any;
        getFlagsForElementVnode: (type: string) => number;
        internal_DOMNodeMap: Map<any, any>;
        internal_isUnitlessNumber: Set<string>;
        internal_normalize: (vNode: VNode) => void;
        internal_patch: (lastVNode: VNode, nextVNode: VNode, parentDom: Element, lifecycle: Function[], context: Object, isSVG: boolean) => void;
        linkEvent: (data: any, event: any) => {
            data: any;
            event: any;
        } | null;
        options: {
            afterMount: Function | null;
            afterRender: Function | null;
            afterUpdate: Function | null;
            beforeRender: Function | null;
            beforeUnmount: Function | null;
            createVNode: Function | null;
            findDOMNodeEnabled: boolean;
            roots: _Root[];
        };
        render: (input: InfernoInput, parentDom: Element | Node | HTMLElement | DocumentFragment | SVGAElement | null, callback?: Function | undefined) => InfernoChildren;
        version: string | undefined;
    };
    export default _default;
    export { Component, EMPTY_OBJ, InfernoChildren, InfernoInput, NO_OP, Props, VNode, cloneVNode, createPortal, createRenderer, createVNode, findDOMNode, getFlagsForElementVnode, internal_DOMNodeMap, internal_isUnitlessNumber, internal_normalize, internal_patch, linkEvent, options, render, version };
}

declare module 'inferno/core/implementation' {
    export interface VNode {
        children: InfernoChildren;
        dom: Element | null;
        className: string | null;
        flags: number;
        key: any;
        parentVNode: VNode | null;
        props: Props | null;
        ref: Ref | Refs | null;
        type: any;
    }
    export type InfernoInput = VNode | null | string | number;
    export type Ref = (node?: Element | null) => void;
    export type InfernoChildren = string | number | boolean | undefined | VNode | Array<string | number | VNode> | null;
    export interface Props {
        children?: InfernoChildren;
        ref?: Ref | null;
        key?: any;
        className?: string;
        [k: string]: any;
    }
    export interface Refs {
        onComponentDidMount?: (domNode: Element) => void;
        onComponentWillMount?(): void;
        onComponentShouldUpdate?(lastProps: any, nextProps: any): boolean;
        onComponentWillUpdate?(lastProps: any, nextProps: any): void;
        onComponentDidUpdate?(lastProps: any, nextProps: any): void;
        onComponentWillUnmount?(domNode: Element): void;
    }
    export function createVNode(flags: number, type: any, className?: string | null, children?: InfernoChildren, props?: Props | null, key?: any, ref?: Ref | Refs | null, noNormalise?: boolean): VNode;
    export function directClone(vNodeToClone: VNode): VNode;
    /**
      * Clones given virtual node by creating new instance of it
      * @param {VNode} vNodeToClone virtual node to be cloned
      * @param {Props=} props additional props for new virtual node
      * @param {...*} _children new children for new virtual node
      * @returns {VNode} new virtual node
      */
    export function cloneVNode(vNodeToClone: VNode, props?: Props, ..._children: InfernoChildren[]): VNode;
    export function createVoidVNode(): VNode;
    export function createTextVNode(text: string | number, key: any): VNode;
    export function isVNode(o: VNode): boolean;
    export function normalizeVNodes(nodes: any[]): VNode[];
    export function getFlagsForElementVnode(type: string): number;
    export function normalize(vNode: VNode): void;
    export interface Root {
        dom: Element | SVGAElement;
        input: VNode;
    }
    export const options: {
        afterMount: null | Function;
        afterRender: null | Function;
        afterUpdate: null | Function;
        beforeRender: null | Function;
        beforeUnmount: null | Function;
        createVNode: null | Function;
        findDOMNodeEnabled: boolean;
        roots: Root[];
    };
}

declare module 'inferno/DOM/constants' {
    /**
        * @module Inferno
        */ /** TypeDoc Comment */
    export const xlinkNS = "http://www.w3.org/1999/xlink";
    export const xmlNS = "http://www.w3.org/XML/1998/namespace";
    export const svgNS = "http://www.w3.org/2000/svg";
    export const strictProps: Set<string>;
    export const booleanProps: Set<string>;
    export const namespaces: Map<string, string>;
    export const isUnitlessNumber: Set<string>;
    export const skipProps: Set<string>;
    export const delegatedEvents: Set<string>;
}

declare module 'inferno/DOM/events/linkEvent' {
    /**
      * Links given data to event as first parameter
      * @param {*} data data to be linked, it will be available in function as first parameter
      * @param {Function} event Function to be called when event occurs
      * @returns {{data: *, event: Function}}
      */
    export function linkEvent(data: any, event: any): {
        data: any;
        event: any;
    } | null;
}

declare module 'inferno/DOM/patching' {
    import { VNode } from "inferno/core/implementation";
    export function patch(lastVNode: VNode, nextVNode: VNode, parentDom: Element, lifecycle: Function[], context: Object, isSVG: boolean): void;
    export function patchElement(lastVNode: VNode, nextVNode: VNode, parentDom: Element | null, lifecycle: Function[], context: Object, isSVG: boolean): void;
    export function updateClassComponent(instance: any, nextState: any, nextVNode: VNode, nextProps: any, parentDom: any, lifecycle: Function[], context: any, isSVG: boolean, force: boolean, fromSetState: boolean): void;
    export function patchComponent(lastVNode: any, nextVNode: any, parentDom: any, lifecycle: Function[], context: any, isSVG: boolean, isClass: boolean): void;
    export function patchText(lastVNode: VNode, nextVNode: VNode): void;
    export function patchVoid(lastVNode: VNode, nextVNode: VNode): void;
    export function patchNonKeyedChildren(lastChildren: any, nextChildren: any, dom: any, lifecycle: Function[], context: Object, isSVG: boolean, lastChildrenLength: number, nextChildrenLength: number): void;
    export function patchKeyedChildren(a: VNode[], b: VNode[], dom: any, lifecycle: Function[], context: any, isSVG: boolean, aLength: number, bLength: number): void;
}

declare module 'inferno/DOM/rendering' {
    import { InfernoChildren, InfernoInput, VNode } from "inferno/core/implementation";
    export function findDOMNode(ref: any): any;
    export function render(input: InfernoInput, parentDom: Element | SVGAElement | DocumentFragment | null | HTMLElement | Node, callback?: Function): InfernoChildren;
    export function createRenderer(parentDom?: any): (lastInput: any, nextInput: any) => void;
    export function createPortal(children: any, container: any): VNode;
}

declare module 'inferno/DOM/utils/common' {
    export const EMPTY_OBJ: {};
    export function setTextContent(dom: any, text: string | number): void;
    export function updateTextContent(dom: any, text: string | number): void;
    export function appendChild(parentDom: any, dom: any): void;
    export function insertOrAppend(parentDom: any, newNode: any, nextNode: any): void;
    export function documentCreateElement(tag: any, isSVG: boolean): Element;
    export function replaceChild(parentDom: any, newDom: any, lastDom: any): void;
    export function removeChild(parentDom: Element, dom: Element): void;
    export function isKeyed(lastChildren: any[], nextChildren: any[]): boolean;
    export const componentToDOMNodeMap: Map<any, any>;
    export function callAll(arrayFn: Function[]): void;
}

declare module 'inferno/core/component' {
    import { Props, VNode } from "inferno/core/implementation";
    export class Component<P, S> {
        static defaultProps: {} | null;
        state: S | null;
        props: P & Props;
        context: any;
        $BR: boolean;
        $BS: boolean;
        $PSS: boolean;
        $PS: S | null;
        $LI: any;
        $V: VNode | null;
        $UN: boolean;
        _lifecycle: null;
        $CX: null;
        $UPD: boolean;
        $QU: Function[] | null;
        constructor(props?: P, context?: any);
        componentDidMount?(): void;
        componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: P, nextContext: any): void;
        shouldComponentUpdate?(nextProps: P, nextState: S, nextContext: any): boolean;
        componentWillUpdate?(nextProps: P, nextState: S, nextContext: any): void;
        componentDidUpdate?(prevProps: P, prevState: S, prevContext: any): void;
        componentWillUnmount?(): void;
        getChildContext?(): void;
        forceUpdate(callback?: Function): void;
        setState(newState: {
            [k in keyof S]?: S[k];
        } | Function, callback?: Function): void;
        render(nextProps?: P, nextState?: any, nextContext?: any): any;
    }
}

